import path from 'path'
import nodeExternals from 'webpack-node-externals'

const config = {
  mode: 'development',
  target: 'web',
  entry: {
    'dagre-d3': './index.js'
  },
  output: {
    path: path.join(__dirname, 'dist'),
    filename: '[name].js',
    library: 'dagreD3',
    libraryTarget: 'umd',
    libraryExport: 'default'
  },

  resolve: {
    modules: ['/usr/lib/nodejs', '/usr/share/nodejs', 'node_modules'],
  },

  resolveLoader: {
    modules: ['/usr/lib/nodejs', '/usr/share/nodejs'],
  },

  module: {
    rules: [
      {
        test: /\.js$/,
        use: {
          loader: 'babel-loader'
        }
      }
    ]
  },
  devtool: 'source-map'
}

const coreConfig = {
  mode: 'development',
  target: 'node',
  externals: [nodeExternals()],
  entry: {
    'dagre-d3': './index.js'
  },
  output: {
    path: path.join(__dirname, 'dist'),
    filename: '[name].core.js',
    libraryTarget: 'commonjs2'
  },

  resolve: {
    modules: ['/usr/lib/nodejs', '/usr/share/nodejs', 'node_modules'],
  },

  resolveLoader: {
    modules: ['/usr/lib/nodejs', '/usr/share/nodejs'],
  },

  module: {
    rules: [
      {
        test: /\.js$/,
        use: {
          loader: 'babel-loader'
        }
      }
    ]
  },
  devtool: 'source-map'
}

export default [config, coreConfig]
