'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _webpackNodeExternals = require('webpack-node-externals');

var _webpackNodeExternals2 = _interopRequireDefault(_webpackNodeExternals);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var config = {
  mode: 'development',
  target: 'web',
  entry: {
    'dagre-d3': './index.js'
  },
  output: {
    path: _path2.default.join(__dirname, 'dist'),
    filename: '[name].js',
    library: 'dagreD3',
    libraryTarget: 'umd',
    libraryExport: 'default'
  },

  resolve: {
    modules: ['/usr/lib/nodejs', '/usr/share/nodejs', 'node_modules']
  },

  resolveLoader: {
    modules: ['/usr/lib/nodejs', '/usr/share/nodejs']
  },

  module: {
    rules: [{
      test: /\.js$/,
      use: {
        loader: 'babel-loader'
      }
    }]
  },
  devtool: 'source-map'
};

var coreConfig = {
  mode: 'development',
  target: 'node',
  externals: [(0, _webpackNodeExternals2.default)()],
  entry: {
    'dagre-d3': './index.js'
  },
  output: {
    path: _path2.default.join(__dirname, 'dist'),
    filename: '[name].core.js',
    libraryTarget: 'commonjs2'
  },

  resolve: {
    modules: ['/usr/lib/nodejs', '/usr/share/nodejs', 'node_modules']
  },

  resolveLoader: {
    modules: ['/usr/lib/nodejs', '/usr/share/nodejs']
  },

  module: {
    rules: [{
      test: /\.js$/,
      use: {
        loader: 'babel-loader'
      }
    }]
  },
  devtool: 'source-map'
};

exports.default = [config, coreConfig];
